#include "BarinkEngine.h"

EngineStatistics ES;
BarinkEngine::Renderer renderer;
int main(int argc, char* argv[]) {
	// Setup performance sampler 
	PerfomanceSamplerInit();


	// Startup services 
	BarinkWindow MainWindow =  BarinkWindow(800, 600);

	renderer = BarinkEngine::Renderer();
	InputSystem = BarinkEngine::InputManager();
	ES = EngineStatistics();
	

	InputSystem.attach(&MainWindow);

	GUIManager GUISystem = GUIManager(&MainWindow);


	glEnable(GL_DEPTH_TEST);



	// First call to setup game
	Start();


	
	// Runtime loop
	while (!MainWindow.WindowShouldClose()) {

		SamplePerformance();


		// Execute main logic 
		InputSystem.PollEvents();
		
		Update();

		GUISystem.Render();
		
		MainWindow.SwapBuffers();

		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	}


	// Shutdown game
	Stop();


	// Shutdown Services

	return 0;
}

